Class: Sketchup::View

Inherits:
Object
  • Object
show all

Overview

This class contains methods to manipulate the current point of view of the model. The drawing methods here (draw_line, draw_polyline, etc) are meant to be invoked within a tool's Tool.draw method. Calling them outside Tool.draw will have no effect.

You access the View by calling the Model.active_view method.

Examples:

view = Sketchup.active_model.active_view

Version:

  • SketchUp 6.0

Instance Method Summary # collapse

Instance Method Details

#add_observer(observer) ⇒ Object

The add_observer method is used to add an observer to the current object.

Examples:

view = Sketchup.active_model.active_view
status = view.add_observer observer

Returns true if successful, false if unsuccessful.

Parameters:

  • observer

    An observer.

Returns:

  • true if successful, false if unsuccessful.

Version:

  • SketchUp 6.0

#animation(animation) ⇒ Object

The animation= method is used to set an animation that is displayed for a view. See Animation for details on how to create an animation object.

Examples:

animation = ViewSpinner.new
model = Sketchup.active_model
view = model.active_view
anim = view.animation=animation
if (anim)
  UI.messagebox anim
else
  UI.messagebox "Failure"
end

Returns animation - the newly set Animation object

Parameters:

  • animation

    An Animation object.

Returns:

  • animation - the newly set Animation object

Version:

  • SketchUp 6.0

#average_refresh_timeObject

The average_refresh_time is used to set the average time used to refresh the current model in the view. This can be used to estimate the frame rate for an animation.

Examples:

model = Sketchup.active_model
view = model.active_view
time = view.average_refresh_time

Returns:

  • time - the time in milliseconds

Version:

  • SketchUp 6.0

#cameraObject

The camera method is used to retrieve the camera for the view.

Examples:

camera = view.camera

Returns:

  • camera - a Camera object

Version:

  • SketchUp 6.0

#camera=(camera) ⇒ Object #camera=(camera_and_transition) ⇒ Object

The camera= method is used to set the camera for the view. If a transition time is given, then it will animate the transition from the current camera to the new one.

Examples:

camera2 = Sketchup.Camera.new
model = Sketchup.active_model
view = model.active_view
status = view.camera=camera2

Overloads:

  • #camera=(camera) ⇒ Object

    Returns nil

    Parameters:

    Returns:

    • nil

  • #camera=(camera_and_transition) ⇒ Object

    Returns nil

    Parameters:

    • camera_and_transition (Array(Sketchup::Camera, Float))

      The second item in the array represent the transition time from the existing camera to the

    Returns:

    • nil

Version:

  • SketchUp 6.0

#centerObject

The center method is used to retrieve the coordinates of the center of the view in pixels. It is returned as an array of 2 values for x and y.

Examples:

model = Sketchup.active_model
view = model.active_view
c = view.center

Returns:

  • center - the center of the view

Version:

  • SketchUp 6.0

#corner(index) ⇒ Object

The corner method is used to retrieve the coordinates of one of the corners of the view. The argument is an index between 0 and 3 that identifies which corner you want. This method returns an array with two integers which are the coordinates of the corner of the view in the view space. If the view uses a Camera with a fixed aspect ratio, then the corners are the corners of the viewing are of the camera which might be different than the actual corners of the view itself.

The index numbers are as follows:

- 0: top left,
- 1: top right,
- 2: bottom left,
- 3: bottom right.

Examples:

point = view.corner index

Returns point - a 2d array [w,h] representing the screen point

Parameters:

  • index

    A value between (or including) 0 and 3 identifying the corner whose coordinate you want to retrieve.

Returns:

  • point - a 2d array [w,h] representing the screen point

Version:

  • SketchUp 6.0

#draw(mode, points) ⇒ Sketchup::View

Note:

If you draw outside the model bounds you need to implement Tool#getExtents which return a bounding box large enough to include the points you draw. Otherwise your drawing will be clipped.

The #draw method is used to do basic drawing. This method can only be called from within the Tool#draw method of a tool that you implement in Ruby.

The following constants are all OpenGL terms and have been externalized to Ruby. Here is a summary of their meanings:

GL_POINTS

Treats each vertex as a single point. Vertex n defines point n. N points are drawn.

GL_LINES

Treats each pair of vertices as an independent line segment. Vertices 2n-1 and 2n define line n. N/2 lines are drawn.

GL_LINE_STRIP

Draws a connected group of line segments from the first vertex to the last. Vertices n and n+1 define line n. N-1 lines are drawn.

GL_LINE_LOOP

Draws a connected group of line segments from the first vertex to the last, then back to the first. Vertices n and n+1 define line n. The last line, however, is defined by vertices N and 1. N lines are drawn.

GL_TRIANGLES

Treats each triplet of vertices as an independent triangle. Vertices 3n-2, 3n-1, and 3n define triangle n. N/3 triangles are drawn.

GL_TRIANGLE_STRIP

Draws a connected group of triangles. One triangle is defined for each vertex presented after the first two vertices. For odd n, vertices n, n+1, and n+2 define triangle n. For even n, vertices n+1, n, and n+2 define triangle n. N-2 triangles are drawn.

GL_TRIANGLE_FAN

Draws a connected group of triangles. One triangle is defined for each vertex presented after the first two vertices. Vertices 1, n+1, and n+2 define triangle n. N-2 triangles are drawn.

GL_QUADS

Treats each group of four vertices as an independent quadrilateral. Vertices 4n-3, 4n-2, 4n-1, and 4n define quadrilateral n. N/4 quadrilaterals are drawn.

GL_QUAD_STRIP

Draws a connected group of quadrilaterals. One quadrilateral is defined for each pair of vertices presented after the first pair. Vertices 2n-1, 2n, 2n+2, and 2n+1 define quadrilateral n. N/2-1 quadrilaterals are drawn. Note that the order in which vertices are used to construct a quadrilateral from strip data is different from that used with independent data.

GL_POLYGON

Draws a single, convex polygon. Vertices 1 through N define this polygon.

Examples:

points = [
  Geom::Point3d.new(0, 0, 0),
  Geom::Point3d.new(9, 0, 0),
  Geom::Point3d.new(9, 9, 0),
  Geom::Point3d.new(0, 9, 0)
]
view.draw(GL_LINE_LOOP, points)

Parameters:

  • mode (Integer)

    The item you are going to draw, one of the constants from the comments, such as GL_LINES.

  • points (Array<Geom::Point3d>)

Returns:

See Also:

Version:

  • SketchUp 6.0

#draw2d(openglenum, points) ⇒ Sketchup::View

The #draw2d method is used to draw in screen space (using 2D screen coordinates) instead of 3D space.

The second parameter is an Array of Geom::Point3d objects (or several individual Geom::Point3d objects). These Geom::Point3d objects are in screen space, not 3D space. The X value corresponds to the number of pixels from the left edge of the drawing area. The Y value corresponds to the number of pixels down from the top of the drawing area. The Z value is not used.

Examples:

points = [
  Geom::Point3d.new(0, 0, 0),
  Geom::Point3d.new(8, 0, 0),
  Geom::Point3d.new(8, 4, 0),
  Geom::Point3d.new(0, 4, 0)
]
view.draw2d(GL_LINE_STRIP, points)

Returns the View object.

Parameters:

  • openglenum (Integer)

    An OpenGL enumerator (unsigned integer). See comments in the #draw method for a list of constants.

  • points (Array<Geom::Point3d>)

Returns:

See Also:

Version:

  • SketchUp 6.0

#draw_lines(point_list, ...) ⇒ Object #draw_lines(pts) ⇒ Object

The draw_lines method is used to draw disconnected lines.

You must have an even number of points. This method is usually invoked within the draw method of a tool.

Examples:

point4 = Geom::Point3d.new 0,0,0
point5 = Geom::Point3d.new 100,100,100
# returns a view
status = view.drawing_color="red"
status = view.draw_lines point4, point5

Overloads:

  • #draw_lines(point_list, ...) ⇒ Object

    Returns view - a View object

    Parameters:

    • point_list

      An even number of Point3d objects.

    Returns:

    • view - a View object

  • #draw_lines(pts) ⇒ Object

    Returns view - a View object

    Parameters:

    • pts

      An array of Point3d objects.

    Returns:

    • view - a View object

Version:

  • SketchUp 6.0

#draw_lines(point_list, ...) ⇒ Object #draw_lines(pts) ⇒ Object

The draw_lines method is used to draw disconnected lines.

You must have an even number of points. This method is usually invoked within the draw method of a tool.

Examples:

point4 = Geom::Point3d.new 0,0,0
point5 = Geom::Point3d.new 100,100,100
# returns a view
status = view.drawing_color="red"
status = view.draw_lines point4, point5

Overloads:

  • #draw_lines(point_list, ...) ⇒ Object

    Returns view - a View object

    Parameters:

    • point_list

      An even number of Point3d objects.

    Returns:

    • view - a View object

  • #draw_lines(pts) ⇒ Object

    Returns view - a View object

    Parameters:

    • pts

      An array of Point3d objects.

    Returns:

    • view - a View object

Version:

  • SketchUp 6.0

#draw_points(pts, pointsize, pointstyle, pointcolor) ⇒ Object

This method is used to draw points.

This method is usually invoked within the draw method of a tool.

Examples:

point3 = Geom::Point3d.new 0,0,0
# returns a view
status = view.draw_points point3, 10, 1, "red"

Returns view - a View object

Parameters:

  • pts

    An array of Point3d objects.

  • pointsize (optional)

    Size of the point in pixels.

  • pointstyle (optional)

    Style of the point. 1 = open square, 2 = filled square, 3 = “+”, 4 = “X”, 5 = “*”, 6 = open triangle, 7 = filled triangle.

  • pointcolor (optional)

    Color of the point.

Returns:

  • view - a View object

Version:

  • SketchUp 6.0

#draw_polyline(point_list, ...) ⇒ Object #draw_polyline(pts) ⇒ Object

The draw_polyline method is used to draw a series of connected line segments from pt1 to pt2 to pt3, and so on.

This method is usually invoked within the draw method of a tool.

Examples:

point12 = Geom::Point3d.new 0,0,0
point13 = Geom::Point3d.new 10,10,10
point14 = Geom::Point3d.new 20,20,20
point15 = Geom::Point3d.new 30,30,30
status = view.draw_polyline point12, point13, point14, point15

Overloads:

  • #draw_polyline(point_list, ...) ⇒ Object

    Returns view - a View object

    Parameters:

    • point_list

      An even number of Point3d objects.

    Returns:

    • view - a View object

  • #draw_polyline(pts) ⇒ Object

    Returns view - a View object

    Parameters:

    • pts

      An array of Point3d objects.

    Returns:

    • view - a View object

Version:

  • SketchUp 6.0

#draw_text(point, text, options = {}) ⇒ Sketchup::View

Note:

Under Windows the font name must be less than 32 characters - due to system limitations.

This method is used to draw text on the screen and is usually invoked within the draw method of a tool.

Examples:

view = Sketchup.active_model.active_view

# This works in all SketchUp versions and draws the text using the
# default font, color and size.
point = Geom::Point3d.new(200, 100, 0)
view.draw_text(point, "This is a test")

# This works in SketchUp 2016 and up.
options = {
  :font => "Arial",
  :size => 20,
  :bold => true,
  :align => TextAlignRight
}
point = Geom::Point3d.new(200, 200, 0)
view.draw_text(point, "This is another\ntest", options)

# You can also use Ruby 2.0's named arguments:
point = Geom::Point3d.new(200, 200, 0)
view.draw_text(point, "Hello world!", color: "Red")

Parameters:

  • point (Geom::Point3d)

    A Point3d object representing a 2D coordinate in view space.

  • text (String)

    The text string to draw.

  • options (Hash) (defaults to: {})

    The text can be customized by providing a hash or named arguments of options. Available from SketchUp 2016.

Options Hash (options):

  • :font (String)

    The name of the font to use. If it does not exist on the system, a default font will be used instead.

  • :size (Integer)

    The size of the font in points

  • :bold (Boolean)

    Controls the Bold property of the font.

  • :italic (Boolean)

    Controls the Italic property of the font.

  • :color (Sketchup::Color)

    The color to draw the text with.

  • :align (Integer)

    The text alignment, one of the following constants TextAlignLeft, TextAlignCenter or TextAlignRight.

Returns:

Version:

  • SketchUp 6.0

#drawing_color=(color) ⇒ Object

The drawing_color method is used to set the color that is used for drawing to the view.

This method is usually invoked within the draw method of a tool.

Examples:

view = view.drawing_color = color

Returns view - a View object

Parameters:

  • color

    A Color object.

Returns:

  • view - a View object

Version:

  • SketchUp 6.0

#dynamic=(value) ⇒ Object

The dynamic= method allows you to degrade visual quality while improving performance when a model is large and view refresh time is slow. For example, if you were using a Ruby script to animate the camera through a large scene, you may want to set dynamic to true during that time.

See also camera.rb which is part of the film and stage ruby scripts.

Examples:

view.dynamic = true

Returns nil

Parameters:

  • value

    true or false

Returns:

  • nil

Version:

  • SketchUp 6.0

#field_of_viewObject

The field_of_view method is used get the view's field of view setting, in degrees.

Examples:

fov = Sketchup.active_model.active_view.field_of_view

Returns:

  • fov - the field of view

Version:

  • SketchUp 6.0

#field_of_view=(fov) ⇒ Object

The field_of_view= method is used set the view's field of view setting, in degrees.

Examples:

my_view = Sketchup.active_model.active_view
my_view.field_of_view = 45
my_view.invalidate

Returns status - true if successful

Parameters:

  • fov
    • the field of view

Returns:

  • status - true if successful

Version:

  • SketchUp 6.0

#guess_targetObject

The guess_target method is used to guess at what the user is looking at when you have a perspective view.

This method is useful when writing a viewing tool. See also camera.rb which is part of the film and stage ruby scripts.

Examples:

target = view.guess_target

Returns target - a Point3d object representing the point in the model that the user is likely interested in.

Returns:

  • target - a Point3d object representing the point in the model that the user is likely interested in.

Version:

  • SketchUp 6.0

#inference_locked?Object

The inference_locked? method is used to determine if inference locking is on for the view.

Examples:

model = Sketchup.active_model
view = model.active_view
status = view.inference_locked

Returns:

  • status - true if locked, false if unlocked

  • (Boolean)

Version:

  • SketchUp 6.0

#inputpoint(x, y, inputpoint1) ⇒ Object

The inputpoint method is used to retrieve an input point.

This will normally be used inside one of the mouse event handling methods in a tool. Usually, it is preferable to create the InputPoint first and then use the pick method on it.

Examples:

inputpoint = view.inputpoint x, y, inputpoint1

Returns nil

Parameters:

  • x

    A x value.

  • y

    A y value.

  • inputpoint1

    An InputPoint object.

Returns:

  • nil

Version:

  • SketchUp 6.0

#invalidateObject

Note:

This is the preferred method to update the viewport. Use this before trying to use #refresh.

The invalidate method is used mark the view as in need of a redraw.

Examples:

model = Sketchup.active_model
view = model.active_view
invalidated_view = view.invalidate

Returns:

  • invalidated_view - the invalidated View object

Version:

  • SketchUp 6.0

#last_refresh_timeObject

The last_refresh_time method is used to retrieve the time for the last full view refresh.

Examples:

time = view.last_refresh_time

Returns time - time in milliseconds

Returns:

  • time - time in milliseconds

Version:

  • SketchUp 6.0

#line_stipple(pattern) ⇒ Object

The line_stipple= method is used to set the line pattern to use for drawing. The stipple pattern is given as a string. Valid strings are:

"." (Dotted Line),
"-" (Short Dashes Line),
"_" (Long Dashes Line),
"-.-" (Dash Dot Dash Line),
"" (Solid Line).

This method is usually invoked within the draw method of a tool.

Examples:

point8 = Geom::Point3d.new 0,0,0
point9 = Geom::Point3d.new 100,100,100
view.line_stipple = "-.-"
view = view.draw_lines point8, point9

Returns view - the View object

Parameters:

  • pattern

    A string stipple pattern, such as “-.-”

Returns:

  • view - the View object

Version:

  • SketchUp 6.0

#line_width=(width) ⇒ Object

The line_width= method is used to set the line width to use for drawing. The value is a Double indicating the desired width in pixels.

This method is usually invoked within the draw method of a tool.

Examples:

view.line_width = width

Returns view - a View object

Parameters:

  • width

    The width in pixels.

Returns:

  • view - a View object

Version:

  • SketchUp 6.0

#lock_inference(inputpoint, inputpoint2) ⇒ Object

The lock_inference method is used to lock or unlock an inference.

This method will typically be called from inside a tool class when the user presses the shift key.

With no arguments it unlocks all inferences. With one or two arguments, it locks the inference based on the given InputPoint(s).

Examples:

view = view.lock_inference
view = view.lock_inference inputpoint
view = view.lock_inference inputpoint1, inputpoint2

Returns view - a View object

Parameters:

  • inputpoint (optional)

    1st InputPoint to inference to.

  • inputpoint2 (optional)

    2nd InputPoint to inference to.

Returns:

  • view - a View object

Version:

  • SketchUp 6.0

#modelObject

The model method is used to retrieve the model for the current view.

Examples:

model = view.model

Returns:

  • model - the model for this view

Version:

  • SketchUp 6.0

#pick_helperObject #pick_helper(x, y, aperture = 0) ⇒ Object

The pick_helper method is used to retrieve a pick helper for the view. See the PickHelper class for information on pick helpers.

This call returns an initialized PickHelper.

Examples:

model = Sketchup.active_model
view = model.active_view
ph = view.pick_helper

Overloads:

  • #pick_helperObject

    Returns pickhelper - a PickHelper object

    Returns:

    • pickhelper - a PickHelper object

  • #pick_helper(x, y, aperture = 0) ⇒ Object

    Returns pickhelper - a PickHelper object

    Parameters:

    • x (Integer)
    • y (Integer)
    • aperture (Integer) (defaults to: 0)

    Returns:

    • pickhelper - a PickHelper object

Version:

  • SketchUp 6.0

#pickray(screen_point) ⇒ Object #pickray(x, y) ⇒ Object

The pickray method is used to retrieve a ray passing through a given screen position in the viewing direction.

Examples:

ray = view.pickray x, y

Overloads:

  • #pickray(screen_point) ⇒ Object

    Returns ray - a ray

    Parameters:

    • screen_point (Array(Integer, Integer))

    Returns:

    • ray - a ray

  • #pickray(x, y) ⇒ Object

    Returns ray - a ray

    Parameters:

    • x (Integer)
    • y (Integer)

    Returns:

    • ray - a ray

Version:

  • SketchUp 6.0

#pixels_to_model(pixels, point) ⇒ Object

The pixels_to_model method is used to compute a model size from a pixel size at a given point.

This method is useful for deciding how big to draw something based on a desired size in pixels.

Examples:

size = view.pixels_to_model pixels, point

Returns size - the model size

Parameters:

  • pixels

    The pixel size.

  • point

    A Point3d object where the size will be calculated from.

Returns:

  • size - the model size

Version:

  • SketchUp 6.0

#refreshObject

Note:

This method might impact performance and if used incorrectly cause instability or crashes. Don't use this unless you have verified that you cannot use #invalidate instead.

The refresh method is used to immediately force a redraw of the view.

Examples:

model = Sketchup.active_model
view = model.active_view
refreshed_view = view.refresh

Returns:

  • refreshed_view - the refreshed View object

Version:

  • SketchUp 7.1

#remove_observer(observer) ⇒ Object

The remove_observer method is used to remove an observer from the current object.

Examples:

view = Sketchup.active_model.active_view
status = view.remove_observer observer

Returns true if successful, false if unsuccessful.

Parameters:

  • observer

    An observer.

Returns:

  • true if successful, false if unsuccessful.

Version:

  • SketchUp 6.0

#screen_coords(point3d) ⇒ Object

The screen_coords method is used to retrieve the screen coordinates of the given point on the screen.

The x and y values returned correspond to the x and y screen coordinates. Ignore the z values. If the referenced point is not in the current viewport, the x and/or y value may be negative.

Examples:

point = view.screen_coords(ORIGIN)

Returns x, y - A Point3d containing the screen position

Parameters:

  • point3d

    A Point3d object.

Returns:

  • x, y - A Point3d containing the screen position

Version:

  • SketchUp 6.0

#set_color_from_line(point1, point2) ⇒ Object

Set the drawing color for the view based on the direction of a line that you want to draw. These colors will match the axes colors in the SketchUp model (typically blue for straight up and down, etc.)

This method is usually invoked within the draw method of a tool.

Examples:

view = view.set_color_from_line point1, point2

Returns view - a View object

Parameters:

  • point1

    Point3d object representing first point in the line.

  • point2

    Point3d object representing second point in the line.

Returns:

  • view - a View object

Version:

  • SketchUp 6.0

#show_frame(delay) ⇒ Object

The show_frame method is used to show a frame of an Animation object in the current view.

You can supply an optional delay in seconds to wait before showing the next frame. This can be useful to control the speed at which the animation runs.

Examples:

status = view.show_frame &lt;delay

Returns nil

Parameters:

  • delay

    An optional delay in seconds.

Returns:

  • nil

Version:

  • SketchUp 6.0

#tooltip=(string) ⇒ Object

Set a tooltip to display in the view. This is useful for displaying tooltips in a tool that you write in Ruby.

Examples:

tooltip = view.tooltip = string

Returns tooltip - the new tooltip string

Parameters:

  • string

    The string tooltip.

Returns:

  • tooltip - the new tooltip string

Version:

  • SketchUp 6.0

#vpheightObject

The vpheight method is used to retrieve the height of the viewport for the view.

Examples:

model = Sketchup.active_model
view = model.active_view
height = view.vpheight

Returns:

  • height - the height of the viewport in pixels.

Version:

  • SketchUp 6.0

#vpwidthObject

The vpwidth method is used to retrieve the width of the viewport for the view.

Examples:

width = view.vpwidth

Returns:

  • width - the width of the viewport in pixels.

Version:

  • SketchUp 6.0

#write_image(filename_or_hash, width, height, antialias, compression) ⇒ Object

The write_image method is used to write the current view to an image file.

All arguments except for the filename are optional.

If antialias is specified, it should be either true or false.

If a hash is passed as the first parameter, then the contents of that hash define how the image is exported. The keys are:

- filename        The filename for the saved image.
- width           (optional) Width in pixels (max 16000).
- height          (optional) Height in pixels (max 16000).
- antialias       (optional) true or false
- compression     (optional) Float compression factor for JPEG images,
                  between 0.0 and 1.0
- transparent     true or false

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
UI.messagebox "Now Lets Write the Image"
view = model.active_view
# Puts in SketchUp install directory by default
status = view.write_image "test.jpg"
keys = {
  :filename => "c:/tmp/write_image.png",
  :width => 640,
  :height => 480,
  :antialias => false,
  :compression => 0.9,
  :transparent => true
}
model = Sketchup.active_model
view = model.active_view
view.write_image keys

Returns nil

Parameters:

  • filename_or_hash

    The filename for the saved image or a hash containing a set of keys.

  • width (optional)

    Width in pixels.

  • height (optional)

    Height in pixels.

  • antialias (optional)

    true or false

  • compression (optional)

    Float compression factor for JPEG images, between 0.0 and 1.0

Returns:

  • nil

Version:

  • SketchUp 6.0

#zoom(zoom_or_ents) ⇒ Object

The zoom method is used to zoom in or out by some zoom factor.

Examples:

view = view.zoom factor
view = view.zoom selection
view = view.zoom entity
view = view.zoom array_of_entities

Returns view - the zoomed View object

Parameters:

  • zoom_or_ents

    A Float zoom factor from 1.0 or larger or an Array or collection of entities to “zoom extents” around.

Returns:

  • view - the zoomed View object

Version:

  • SketchUp 6.0

#zoom_extentsObject

The zoom_extents method is used to zoom to the extents about the entire model, as if the user has selected the zoom extents command from the menu.

Examples:

view = Sketchup.active_model.active_view
new_view = view.zoom_extents

Returns:

  • new_view - the zoomed View object

Version:

  • SketchUp 6.0